import * as chai from "chai";
import * as dirtyChai from "dirty-chai";

import { Barcodes } from "@salaxy/core";

describe("Unit tests", () => {
  describe("Barcode generation", () => {
    const expect = chai.expect;
    chai.use(dirtyChai);

    // http://www.finanssiala.fi/maksujenvalitys/dokumentit/Pankkiviivakoodi-opas.pdf

    // Version 4 testilaskujen tietosisällöt
    const version4Examples = [

      // LASKU 1:
      // Tilinro: Sp. FI79 4405 2020 0360 82 Summa: 4 883,15 Viite: 86851 62596 19897 Eräpäivä: 12.6.2010
      // [105] 47 94 40 52 02 00 36 08 20 04 88 31 50 00 00 00 08 68 51 62 59 61 98 97 10 06 12 [40] [stop]
      ["FI79 4405 2020 0360 82", "4 883,15", "86851 62596 19897", "12.6.2010", "47 94 40 52 02 00 36 08 20 04 88 31 50 00 00 00 08 68 51 62 59 61 98 97 10 06 12 40"],

      // LASKU 2:
      // Tilinro: Nordea FI58 1017 1000 0001 22 Summa: 482,99 Viite: 55958 22432 94671 Eräpäivä: 31.1.2012
      // [105] 45 81 01 71 00 00 00 12 20 00 48 29 90 00 00 00 05 59 58 22 43 29 46 71 12 01 31 [55] [stop]
      ["FI58 1017 1000 0001 22", "482,99", "55958 22432 94671", "31.1.2012", "45 81 01 71 00 00 00 12 20 00 48 29 90 00 00 00 05 59 58 22 43 29 46 71 12 01 31 55"],

      // LASKU 3:
      // Tilinro: Op. FI02 5000 4640 0013 02 Summa: 693,80 Viite: 69 87567 20834 35364 Eräpäivä: 24.7.2011
      // [105] 40 25 00 04 64 00 01 30 20 00 69 38 00 00 00 06 98 75 67 20 83 43 53 64 11 07 24 [14] [stop]
      ["FI02 5000 4640 0013 02", "693,80", "69 87567 20834 35364", "24.7.2011", "40 25 00 04 64 00 01 30 20 00 69 38 00 00 00 06 98 75 67 20 83 43 53 64 11 07 24 14"],

      // LASKU 4:
      // Tilinro: ÅAB FI15 6601 0001 5306 41 Summa: 7 444,54 Viite: 7 75847 47906 47489 Eräpäivä: 19.12.2019
      // [105] 41 56 60 10 00 15 30 64 10 07 44 45 40 00 00 00 77 58 47 47 90 64 74 89 19 12 19 [63] [stop]
      ["FI15 6601 0001 5306 41", "7 444,54", "7 75847 47906 47489", "19.12.2019", "41 56 60 10 00 15 30 64 10 07 44 45 40 00 00 00 77 58 47 47 90 64 74 89 19 12 19 63"],

      // LASKU 5:
      // Tilinro: Sampo FI16 8000 1400 0502 67 Summa: 935,85 Viite: 78 77767 96566 28687 Eräpäivä: Ei eräpäivää
      // [105] 41 68 00 01 40 00 50 26 70 00 93 58 50 00 00 07 87 77 67 96 56 62 86 87 00 00 00 [30] [stop]
      ["FI16 8000 1400 0502 67", "935,85", "78 77767 96566 28687", "", "41 68 00 01 40 00 50 26 70 00 93 58 50 00 00 07 87 77 67 96 56 62 86 87 00 00 00 30"],

      // LASKU 6:
      // Tilinro: Handelsbanken FI73 3131 3001 0000 58 Summa: 0,00 Viite: 8 68624 Eräpäivä: 9.8.2013
      // [105] 47 33 13 13 00 10 00 05 80 00 00 00 00 00 00 00 00 00 00 00 00 86 86 24 13 08 09 [68] [stop]
      ["FI73 3131 3001 0000 58", "0,00", "8 68624", "9.8.2013", "47 33 13 13 00 10 00 05 80 00 00 00 00 00 00 00 00 00 00 00 00 86 86 24 13 08 09 68"],

      // LASKU 7:
      // Tilinro: SEB FI83 3301 0001 1007 75 Summa: 150000,20 Viite: 92125 37425 25398 97737 Eräpäivä: 25.5.2016
      // [105] 48 33 30 10 00 11 00 77 51 50 00 02 00 00 92 12 53 74 25 25 39 89 77 37 16 05 25 [45] [stop]
      ["FI83 3301 0001 1007 75", "150000,20", "92125 37425 25398 97737", "25.5.2016", "48 33 30 10 00 11 00 77 51 50 00 02 00 00 92 12 53 74 25 25 39 89 77 37 16 05 25 45"],

      // LASKU 8:
      // Tilinro: Tapiola FI39 3636 3002 0924 92 Summa: 1,03 Viite: 5907 38390 Eräpäivä: 11.3.2023
      // [105] 43 93 63 63 00 20 92 49 20 00 00 10 30 00 00 00 00 00 00 05 90 73 83 90 23 03 11 [9] [stop]
      ["FI39 3636 3002 0924 92", "1,03", "5907 38390", "11.3.2023", "43 93 63 63 00 20 92 49 20 00 00 10 30 00 00 00 00 00 00 05 90 73 83 90 23 03 11 09"],

      // LASKU 9:
      // Tilinro: S-Pankki FI92 3939 0001 0033 91 Summa: 0,02 Viite: 13 57914 Eräpäivä: 24.12.2099
      // [105] 49 23 93 90 00 10 03 39 10 00 00 00 20 00 00 00 00 00 00 00 01 35 79 14 99 12 24 [30] [stop]
      ["FI92 3939 0001 0033 91", "0,02", "13 57914", "24.12.2099", "49 23 93 90 00 10 03 39 10 00 00 00 20 00 00 00 00 00 00 00 01 35 79 14 99 12 24 30"],
    ];

    // Version 5 testilaskujen tietosisällöt
    const version5Examples = [

      // LASKU 1:
      // Tilinro: Sp. FI79 4405 2020 0360 82 Summa: 4883,15 Viite: RF09 8685 1625 9619 897 Eräpäivä: 12.6.2010
      // [105] 57 94 40 52 02 00 36 08 20 04 88 31 50 90 00 00 08 68 51 62 59 61 98 97 10 06 12 [74] [stop]
      ["FI79 4405 2020 0360 82", "4 883,15", "RF09 8685 1625 9619 897", "12.6.2010", "57 94 40 52 02 00 36 08 20 04 88 31 50 90 00 00 08 68 51 62 59 61 98 97 10 06 12 74"],

      // LASKU 2:
      // Tilinro: Nordea FI58 1017 1000 0001 22 Summa: 482,99 Viite: RF06 5595 8224 3294 671 Eräpäivä: 31.1.2010
      // [105] 55 81 01 71 00 00 00 12 20 00 48 29 90 60 00 00 05 59 58 22 43 29 46 71 10 01 31 [31] [stop]
      ["FI58 1017 1000 0001 22", "482,99", "RF06 5595 8224 3294 671", "31.1.2010", "55 81 01 71 00 00 00 12 20 00 48 29 90 60 00 00 05 59 58 22 43 29 46 71 10 01 31 31"],

      // LASKU 3:
      // Tilinro: Op. FI02 5000 4640 0013 02 Summa: 693,80 Viite: RF02 6987 5672 0834 Eräpäivä: 24.7.2011
      // [105] 50 25 00 04 64 00 01 30 20 00 69 38 00 20 00 00 00 00 69 87 56 72 08 34 11 07 24 [79] [stop]
      ["FI02 5000 4640 0013 02", "693,80", "RF02 6987 5672 0834", "24.7.2011", "50 25 00 04 64 00 01 30 20 00 69 38 00 20 00 00 00 00 69 87 56 72 08 34 11 07 24 79"],

      // LASKU 4:
      // Tilinro: ÅAB FI15 6601 0001 5306 41 Summa: 7 444,54 Viite: RF84 7758 4747 9064 7489 Eräpäivä: 19.12.2019
      // [105] 51 56 60 10 00 15 30 64 10 07 44 45 48 40 00 00 77 58 47 47 90 64 74 89 19 12 19 [16] [stop]
      ["FI15 6601 0001 5306 41", "7 444,54", "RF84 7758 4747 9064 7489", "19.12.2019", "51 56 60 10 00 15 30 64 10 07 44 45 48 40 00 00 77 58 47 47 90 64 74 89 19 12 19 16"],

      // LASKU 5:
      // Tilinro: Sampo FI16 8000 1400 0502 67 Summa: 935,85 Viite: RF60 7877 7679 6566 2868 7 Eräpäivä: Ei eräpäivää
      // [105] 51 68 00 01 40 00 50 26 70 00 93 58 56 00 00 07 87 77 67 96 56 62 86 87 00 00 00 [15] [stop]
      ["FI16 8000 1400 0502 67", "935,85", "RF60 7877 7679 6566 2868 7", false, "51 68 00 01 40 00 50 26 70 00 93 58 56 00 00 07 87 77 67 96 56 62 86 87 00 00 00 15"],

      // LASKU 6:
      // Tilinro: Handelsbanken FI73 3131 3001 0000 58 Summa: 0,00 Viite: RF10 8686 24 Eräpäivä: 9.8.2013
      // [105] 57 33 13 13 00 10 00 05 80 00 00 00 01 00 00 00 00 00 00 00 00 86 86 24 13 08 09 [91] [stop]
      ["FI73 3131 3001 0000 58", "0,00", "RF10 8686 24", "9.8.2013", "57 33 13 13 00 10 00 05 80 00 00 00 01 00 00 00 00 00 00 00 00 86 86 24 13 08 09 91"],

      // LASKU 7:
      // Tilinro: SEB FI83 3301 0001 1007 75 Summa: 150000,20 Viite: RF71 9212 5374 2525 3989 7737 Eräpäivä: 25.5.2016
      // [105] 58 33 30 10 00 11 00 77 51 50 00 02 07 10 92 12 53 74 25 25 39 89 77 37 16 05 25 [80] [stop]
      ["FI83 3301 0001 1007 75", "150000,20", "RF71 9212 5374 2525 3989 7737", "25.5.2016", "58 33 30 10 00 11 00 77 51 50 00 02 07 10 92 12 53 74 25 25 39 89 77 37 16 05 25 80"],

      // LASKU 8:
      // Tilinro: Tapiola FI39 3636 3002 0924 92 Summa: 1,03 Viite: RF66 5907 3839 0 Eräpäivä: 11.3.2023
      // [105] 53 93 63 63 00 20 92 49 20 00 00 10 36 60 00 00 00 00 00 05 90 73 83 90 23 03 11 [10] [stop]
      ["FI39 3636 3002 0924 92", "1,03", "RF66 5907 3839 0", "11.3.2023", "53 93 63 63 00 20 92 49 20 00 00 10 36 60 00 00 00 00 00 05 90 73 83 90 23 03 11 10"],

      // LASKU 9:
      // Tilinro: S-Pankki FI92 3939 0001 0033 91 Summa: 0,02 Viite: RF95 1357 914 Eräpäivä: 24.12.2099
      // [105] 59 23 93 90 00 10 03 39 10 00 00 00 29 50 00 00 00 00 00 00 01 35 79 14 99 12 24 [33] [stop]
      ["FI92 3939 0001 0033 91", "0,02", "RF95 1357 914", "24.12.2099", "59 23 93 90 00 10 03 39 10 00 00 00 29 50 00 00 00 00 00 00 01 35 79 14 99 12 24 33"],
    ];

    let i = 1;
    for (const item of version4Examples) {
      it("Generates valid barcode values with version 4 spec - Example #" + i, () => {
        expect(Barcodes.getValue(item[0], item[2], item[3], item[1], true)).to.equal(item[4].replace(/\s/g, ""));
      });
      i++;
    }

    i = 1;
    for (const item of version5Examples) {
      it("Generates valid barcode values with version 5 spec - Example #" + i, () => {
        expect(Barcodes.getValue(item[0] as string, item[2] as string, item[3] as string, item[1] as string, true)).to.equal((item[4] as string).replace(/\s/g, ""));
      });
      i++;
    }

  });
});
